package com.osi.notification.actors;

import akka.actor.UntypedActor;

import com.osi.notification.destination.DestinationDestroyer;
import com.osi.notification.subscription.SubscriptionHelper;

@SuppressWarnings("unchecked")
public class RESTUnsubscribeActor extends UntypedActor {
	
	private final String unsubscribeUri;
	private final DestinationDestroyer destinationRemover;
	
	public RESTUnsubscribeActor(String unsubscribeUri, DestinationDestroyer remover) {
		this.unsubscribeUri = unsubscribeUri;
		this.destinationRemover = remover;
	}

	@Override
	public void onReceive(Object message) throws Exception {
		SubscriptionHelper.unsubscribe(unsubscribeUri);
		if (destinationRemover != null) {
			destinationRemover.remove();
		}
		getContext().replyUnsafe("");
	}

}
